"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var contentstack_1 = require("contentstack");
var package_json_1 = require("../package.json");
var data_plugin_tools_1 = require("@builder.io/data-plugin-tools");
var capitalize_1 = require("lodash/capitalize");
var kebabCase_1 = require("lodash/kebabCase");
var fromPairs_1 = require("lodash/fromPairs");
var app_context_1 = require("@builder.io/app-context");
function humanCase(str) {
    if (str === void 0) { str = ''; }
    if (str.includes('$')) {
        // kebabCase removes the $ but we need to keep it for chart names
        return kebabCase_1.default(str.replace(/[- ]+/g, ' ').trim());
    }
    return kebabCase_1.default(capitalize_1.default(str)
        .replace(/[- ]+/g, ' ')
        .trim());
}
// You can see what data types are valid in this doc:
// https://www.contentstack.com/docs/developers/create-content-types/json-schema-for-creating-a-content-type/
var filterableDataTypes = ['isodate', 'text', 'boolean', 'number'];
var buildInputs = function (model) { return function () {
    var subFields = model.schema
        .filter(function (field) { return filterableDataTypes.includes(field.data_type); })
        .map(function (field) { return (__assign({ name: field.uid, friendlyName: field.display_name }, (field.data_type === 'boolean'
        ? {
            type: 'string',
            defaultValue: null,
            enum: [
                {
                    label: 'True',
                    value: 'true',
                },
                {
                    label: 'False',
                    value: 'false',
                },
                {
                    label: 'ALL',
                    value: null,
                },
            ],
        }
        : { type: field.data_type }))); });
    var inputs = [
        { name: 'limit', type: 'number', defaultValue: 10 },
        {
            name: 'orderBy',
            friendlyName: 'Order By',
            type: 'object',
            subFields: [
                {
                    name: 'value',
                    friendlyName: 'Order By',
                    type: 'string',
                    enum: __spreadArrays([
                        {
                            value: null,
                            label: 'DEFAULT',
                        },
                        {
                            value: 'created_at',
                            label: 'Created At',
                        },
                        {
                            value: 'updated_at',
                            label: 'Updated At',
                        }
                    ], subFields.map(function (field) {
                        var _a;
                        return ({
                            value: field.name,
                            label: (_a = field.friendlyName, (_a !== null && _a !== void 0 ? _a : '')),
                        });
                    })),
                },
                {
                    name: 'order',
                    friendlyName: 'order',
                    type: 'string',
                    enum: [
                        {
                            value: 'asc',
                            label: 'ascending',
                        },
                        {
                            value: 'desc',
                            label: 'descending',
                        },
                    ],
                    defaultValue: 'asc',
                },
            ],
        },
        {
            name: 'fields',
            type: 'object',
            advanced: true,
            friendlyName: "Search by " + model.title + " fields",
            subFields: subFields,
        },
    ];
    return inputs;
}; };
/** https://www.contentstack.com/docs/developers/apis/content-delivery-api/#search-by-regex */
var transformFieldQuery = function (query) { return ({
    $regex: ".*" + query + ".*",
    $options: 'i',
}); };
var transformFieldsFilters = function (fields) {
    if (fields) {
        var nonEmptyFieldsQueries = Object.keys(fields).filter(function (fieldKey) {
            var query = fields[fieldKey];
            return (
            // this excludes the  ALL boolean value
            query !== null ||
                // this excludes empty strings
                (typeof query === 'string' && query.length > 0) ||
                // this excludes `NaN` numbers`
                Number.isInteger(query));
        });
        if (nonEmptyFieldsQueries.length > 0) {
            return fromPairs_1.default(nonEmptyFieldsQueries.map(function (key) { return [key, transformFieldQuery(fields[key])]; }));
        }
        else {
            return undefined;
        }
    }
    else {
        return undefined;
    }
};
data_plugin_tools_1.registerDataPlugin({
    name: 'Contentstack',
    id: package_json_1.default.name,
    icon: 'https://cdn.builder.io/api/v1/image/assets%2FYJIGb4i01jvw0SRdL5Bt%2F490404fa90f74ec8b6ea44c345e7ba64',
    settings: [
        {
            name: 'apiKey',
            type: 'string',
            required: true,
            helperText: 'To get your API Key, go to https://app.contentstack.com, choose a Stack and click Settings -> Stack.',
        },
        {
            name: 'deliveryToken',
            type: 'string',
            required: true,
            helperText: 'https://www.contentstack.com/docs/developers/create-tokens/create-a-delivery-token/',
        },
        {
            name: 'environmentName',
            type: 'string',
            required: true,
            helperText: 'Enter the name of your Stack Environment that you want to read data from.',
        },
    ],
    ctaText: "Connect your ContentStack stack",
}, function (settings) { return __awaiter(void 0, void 0, void 0, function () {
    var apiKey, deliveryToken, environmentName, Stack, apiOperations;
    var _a, _b, _c;
    return __generator(this, function (_d) {
        apiKey = (_a = settings.get('apiKey')) === null || _a === void 0 ? void 0 : _a.trim();
        deliveryToken = (_b = settings.get('deliveryToken')) === null || _b === void 0 ? void 0 : _b.trim();
        environmentName = (_c = settings.get('environmentName')) === null || _c === void 0 ? void 0 : _c.trim();
        Stack = contentstack_1.default.Stack(apiKey, deliveryToken, environmentName);
        apiOperations = {
            getResourceTypes: function () { return __awaiter(void 0, void 0, void 0, function () {
                var contentTypesResponse, contentTypes, augmentedContentTypes, buildHeaders;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, Stack.getContentTypes()];
                        case 1:
                            contentTypesResponse = _a.sent();
                            contentTypes = contentTypesResponse.content_types;
                            augmentedContentTypes = contentTypes.map(function (contentType) {
                                var references = contentType.schema.filter(function (field) { return field.data_type === 'reference'; });
                                // https://www.contentstack.com/docs/developers/apis/content-delivery-api/#include-reference
                                var referenceSearchParams = references
                                    .map(function (field) { return field.uid; })
                                    .map(function (includeId) { return ['include[]', includeId]; });
                                return __assign(__assign({}, contentType), { searchParams: { include: referenceSearchParams } });
                            });
                            buildHeaders = function () {
                                var headers = {
                                    api_key: apiKey,
                                    access_token: deliveryToken,
                                };
                                return Object.entries(headers)
                                    .map(function (_a) {
                                    var key = _a[0], value = _a[1];
                                    return "headers." + key + "=" + value;
                                })
                                    .join('&');
                            };
                            return [2 /*return*/, augmentedContentTypes.map(function (model) { return ({
                                    name: humanCase(model.title),
                                    id: model.uid,
                                    description: model.description,
                                    inputs: buildInputs(model),
                                    toUrl: function (options) {
                                        var _a, _b;
                                        var buildUrl = function (url) {
                                            var endUrl = "https://cdn.contentstack.io/v3/content_types/" + model.uid + "/" + url;
                                            return app_context_1.default.config.apiRoot() + "/api/v1/proxy-api?url=" + encodeURIComponent(endUrl) + "&" + buildHeaders();
                                        };
                                        var fieldQueries = transformFieldsFilters(options.fields);
                                        var baseQuery = __spreadArrays([
                                            ['environment', environmentName]
                                        ], (options.limit ? [['limit', options.limit]] : []), (fieldQueries ? [['query', JSON.stringify(fieldQueries)]] : []), (((_a = options.orderBy) === null || _a === void 0 ? void 0 : _a.value) && ((_b = options.orderBy) === null || _b === void 0 ? void 0 : _b.order)
                                            ? [[options.orderBy.order, options.orderBy.value]]
                                            : []));
                                        if (options.entry) {
                                            var query = new URLSearchParams(__spreadArrays(baseQuery, model.searchParams.include));
                                            return buildUrl("entries/" + options.entry + "?" + query);
                                        }
                                        else {
                                            var query = new URLSearchParams(baseQuery);
                                            return buildUrl("entries?" + query);
                                        }
                                    },
                                    canPickEntries: true,
                                }); })];
                    }
                });
            }); },
            getEntriesByResourceType: function (resourceTypeId, options) {
                if (options === void 0) { options = {}; }
                return __awaiter(void 0, void 0, void 0, function () {
                    var StackForContentType, makeApiRequest, response;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                StackForContentType = Stack.ContentType(resourceTypeId);
                                makeApiRequest = function (options) {
                                    if (options.resourceEntryId) {
                                        return StackForContentType.Entry(options.resourceEntryId)
                                            .fetch()
                                            .then(function (res) { return [res]; });
                                    }
                                    else if (options.searchText) {
                                        return StackForContentType.Query()
                                            .search(options.searchText)
                                            .find()
                                            .then(function (res) { return res[0]; });
                                    }
                                    else {
                                        return StackForContentType.Query()
                                            .find()
                                            .then(function (res) { return res[0]; });
                                    }
                                };
                                return [4 /*yield*/, makeApiRequest(options)];
                            case 1:
                                response = _a.sent();
                                return [2 /*return*/, response.map(function (result) {
                                        var item = result.object();
                                        return {
                                            id: item.uid,
                                            name: item.title,
                                        };
                                    })];
                        }
                    });
                });
            },
        };
        return [2 /*return*/, apiOperations];
    });
}); });
//# sourceMappingURL=plugin.js.map